<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/11/2008 *
 * ===================                          Last change: 10/11/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_refback.php                          *
 * -------------------------------------------------------------------- *
 * Short description : Refback settings                                 *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Refback-Einstellungen                            *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

if (isFormSent()) {
	// Replace german decimal comma with computer decimal dot
	if (isPostRequestParameterSet('refback_min_perc')) setPostRequestParameter('refback_min_perc', convertCommaToDot(postRequestParameter('refback_min_perc')));
	if (isPostRequestParameterSet('refback_max_perc')) setPostRequestParameter('refback_max_perc', convertCommaToDot(postRequestParameter('refback_max_perc')));

	// Save configuration
	adminSaveSettingsFromPostData();
} else {
	// Prepare content
	$content = array(
		'refback_enabled_n' => '',
		'refback_enabled_y' => ''
	);

	// Translate Y/N switches
	if (isRefbackEnabled()) {
		// Enabled
		$content['refback_enabled_y'] = ' checked="checked"';
	} else {
		// Disabled
		$content['refback_enabled_n'] = ' checked="checked"';
	}

	// Load template
	loadTemplate('admin_config_refback', false, $content);
}

// [EOF]
?>
