<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 04/30/2005 *
 * ===================                          Last change: 04/30/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_country.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Manage country codes                             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Country codes verwalten                          *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

// Add new code?
if ((isFormSent('add')) && (isPostRequestParameterSet('code')) && (isPostRequestParameterSet('descr'))) {
	// Check if country code does already exist
	$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_countries` WHERE code='%s' LIMIT 1",
	array(strtoupper(postRequestParameter('code'))), __FILE__, __LINE__);
	if (SQL_HASZERONUMS($result)) {
		// Save entry
		SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_countries` (code, descr, is_active) VALUES ('%s','%s','%s')",
		array(
		strtoupper(substr(postRequestParameter('code'), 0, 2)),
		postRequestParameter('descr'),
		postRequestParameter('is_active')
		), __FILE__, __LINE__);

		// Country added
		$message = getMaskedMessage('ADMIN_COUNTRY_ADDED', strtoupper(postRequestParameter('descr')));
	} else {
		// Free memory
		SQL_FREERESULT($result);

		// Does already exist
		$message = getMaskedMessage('ADMIN_COUNTRY_ALREADY', strtoupper(postRequestParameter('code')));
	}

	// Display message
	loadTemplate('admin_settings_saved', false, $message);
} elseif ((isFormSent('change')) && (isPostRequestParameterSet('id'))) {
	// Change all status
	adminChangeActivationStatus(postRequestParameter('id'), 'countries', 'is_active');

	// Show next link
	loadTemplate('admin_next_link', false, array(
		'url'   => 'modules.php?module=admin&amp;what=list_country',
		'title' => '{--ADMIN_COUNTRY_ACTIVATION_NEXT_LINK--}'
	));
} elseif (((isFormSent('edit')) || (isPostRequestParameterSet('delete'))) && (isPostRequestParameterSet('id'))) {
	if (count(postRequestParameter('id')) > 0) {
		if (isFormSent('edit')) {
			// Edit template
			$row    = 'admin_list_country_edit_row';
			$post   = 'modify';
			$class  = 'form_submit';
			$submit = '{--ADMIN_COUNTRY_EDIT_NOW--}';
			$title  = '{--ADMIN_COUNTRY_EDIT_TITLE--}';
			$reset  = '<input type="reset" class="form_reset" value="{--UNDO_SELECTIONS--}" /> ';
		} else {
			// Delete template
			$row    = 'admin_list_country_del_row';
			$post   = 'remove';
			$class  = 'form_delete';
			$submit = '{--ADMIN_COUNTRY_DELETE_NOW--}';
			$title  = '{--ADMIN_COUNTRY_DELETE_TITLE--}';
			$reset  = '';
		}

		// Edit all selected country codes
		$OUT = '';
		foreach (postRequestParameter('id') as $id => $isActive) {
			// Load data from DB
			$result = SQL_QUERY_ESC("SELECT `id`, `code`, `descr` FROM `{?_MYSQL_PREFIX?}_countries` WHERE `id`=%s LIMIT 1",
				array(bigintval($id)), __FILE__, __LINE__);
			if (SQL_NUMROWS($result) == 1) {
				// Load data
				$content = SQL_FETCHARRAY($result);

				if ($post == 'modify') {
					// Generate default selection in edit-mode
					$content['is_active'] = generateOptionList('/ARRAY/', array('Y', 'N'), array('{--YES--}', '{--NO--}'), $isActive);
				} else {
					// Only display status when in delete-mode
					$content['is_active'] = translateYesNo($isActive);
				}

				// Insert row template and switch color
				$OUT .= loadTemplate($row, true, $content);
			} // END - if

			// Free result
			SQL_FREERESULT($result);
		} // END - foreach

		// Prepare content for template
		$content = array(
			'rows'   => $OUT,
			'mode'   => $post,
			'class'  => $class,
			'title'  => $title,
			'submit' => $submit,
			'reset'  => $reset,
		);

		// Load main template
		loadTemplate('admin_list_country_form', false, $content);
	}
} else {
	// Shall we modify / remove entries now?
	$message = ''; initSqls();
	if ((isPostRequestParameterSet('modify')) && (isPostRequestParameterSet('id'))) {
		// Modify
		foreach (postRequestParameter('id') as $id => $sel) {
			addSql("UPDATE `{?_MYSQL_PREFIX?}_countries` SET `code`='" . postRequestParameter('code', $id) . "', `descr`='" . postRequestParameter('descr', $id) . "', `is_active`='" . postRequestParameter('is_active', $id) . "' WHERE `id`=" . bigintval($id) . " LIMIT 1");
		} // END - foreach

		// Create message
		$message = '{--ADMIN_COUNTRIES_MODIFIED--}';
	} elseif ((isFormSent('remove')) && (isPostRequestParameterSet('id'))) {
		// Remove
		$IDs = implode(',', array_keys(postRequestParameter('id')));
		addSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_countries` WHERE `id` IN (".$IDs.") LIMIT ".count(postRequestParameter('id'))."");

		// Create message
		$message = '{--ADMIN_COUNTRIES_REMOVED--}';
	}

	if ((!empty($message)) && (countSqls() > 0)) {
		// Run SQL commands
		runFilterChain('run_sqls');

		// Display message
		loadTemplate('admin_settings_saved', false, $message);
	} // END - if

	// Load currenty setup country codes to list
	$result = SQL_QUERY('SELECT `id`, `code`, `descr`, `is_active` FROM `{?_MYSQL_PREFIX?}_countries` ORDER BY `code` ASC',
	__FILE__, __LINE__);

	// Do we have entries?
	if (!SQL_HASZERONUMS($result)) {
		// List all countries
		$OUT = '';
		while ($content = SQL_FETCHARRAY($result)) {
			// Load row template and switch colors
			$OUT .= loadTemplate('admin_list_country_row', true, $content);
		} // END - while

		// Free memory
		SQL_FREERESULT($result);
	} else {
		// No code setup so far (not possible by this software! 'DE' for 'Deutschland' is default
		$OUT = loadTemplate('admin_list_country_no_row', true);
	}

	// Add list to constant for the template
	$content['rows'] = $OUT;

	// Include add template
	$content['add_form'] = loadTemplate('admin_add_country', true);

	// Load main template
	loadTemplate('admin_list_country', false, $content);
}

// [EOF]
?>
