<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 12/14/2003 *
 * ===================                          Last change: 08/22/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-stats.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Statistics                                       *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Statistiken                                      *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('guest', __FILE__);

// Derterminate which stats we want and set mode and title for the link below stats block
if (!isGetRequestParameterSet('mode')) setGetRequestParameter('mode', strtolower(getConfig('guest_stats')));

// Set config temporarily
setConfigEntry('guest_stats', strtoupper(getRequestParameter('mode')));

switch (getRequestParameter('mode')) {
	case 'members' :
		$lmode = 'modules';
		break;

	case 'modules' :
		$lmode = 'members';
		break;

	case 'inactive':
		$lmode = 'inactive';
		break;

	default:
		// Unsupported mode
		debug_report_bug(__FILE__, __LINE__, sprintf("Unsupported mode <span class=\"data\">%s</span> detected.", secureString(getRequestParameter('mode'))));
		break;
}

// Set link title
$ltitle = '{--GUEST_STATS_' . strtoupper($lmode) . '--}';

// @TODO This can be rewritten in a dynamic include
switch (getConfig('guest_stats')) {
	case 'MEMBERS': // Statistics about your members
		// Only males / females
		$male   = countSumTotalData('M', 'user_data', 'userid', 'gender', true, " AND `status`='CONFIRMED'");
		$female = countSumTotalData('F', 'user_data', 'userid', 'gender', true, " AND `status`='CONFIRMED'");

		// List every month
		$months = array();
		for ($idx = 1; $idx < 13; $idx++) {
			// Copy it so we don't touch the for() loop index
			$month = $idx;

			// Append leading zero
			if ($idx < 10) $month = '0' . $idx;

			// Count months
			$months[$month] = countSumTotalData(bigintval($month), 'user_data', 'userid', 'birth_month', true, " AND `status`='CONFIRMED'");
		} // END - for

		// Members in categories
		$result = SQL_QUERY("SELECT `id`, `cat` FROM `{?_MYSQL_PREFIX?}_cats` WHERE `visible`='Y' ORDER BY `id` ASC", __FILE__, __LINE__);

		// Load categories first
		$cats = array(); $cat_cnt = array();

		// @TODO This can be somehow rewritten
		while ($content = SQL_FETCHARRAY($result)) {
			// Simple...
			$cats[$content['id']] = $content['cat'];
		} // END - while

		// Now we have all categories loaded, count members
		foreach ($cats as $id => $dummy) {
			// We only need id and nothing more to count...
			$cat_cnt[$id] = countSumTotalData(bigintval($id), 'user_cats', 'id', 'cat_id', true);
		} // END - foreach

		// Prepare data for the template
		$content['total_users']   = ($male + $female);
		$content['unconfirmed']   = SQL_NUMROWS(SQL_QUERY("SELECT `userid` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `status` != 'CONFIRMED'", __FILE__, __LINE__));
		$content['total_males']   = $male;
		$content['total_females'] = $female;
		$content['tmem_count']    = SQL_NUMROWS(SQL_QUERY("SELECT `userid` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `last_online` >= {?START_TDAY?} AND `status`='CONFIRMED'", __FILE__, __LINE__));
		$content['ymem_count']    = SQL_NUMROWS(SQL_QUERY("SELECT `userid` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `last_online` >= {?START_YDAY?} AND `last_online` < {?START_TDAY?} AND `status`='CONFIRMED'", __FILE__, __LINE__));
		$content['treg_count']    = SQL_NUMROWS(SQL_QUERY("SELECT `userid` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `joined` >= {?START_TDAY?}", __FILE__, __LINE__));
		$content['yreg_count']    = SQL_NUMROWS(SQL_QUERY("SELECT `userid` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `joined` >= {?START_YDAY?} AND `joined` < {?START_TDAY?}", __FILE__, __LINE__));
		$content['lmode']         = $lmode;
		$content['ltitle']        = $ltitle;

		// Generate monthly stats
		$SW = 2; $r2 = ' right'; $l = 'll'; $r = 'lr'; $OUT = '';
		foreach ($months as $month => $count) {
			if ($SW == 2) $OUT .= '<tr>';

			// Prepare data for template
			$data = array(
				'l_class'  => $l,
				'm_descr'  => $GLOBALS['month_descr'][$month],
				'r_class'  => $r,
				'r2_class' => $r2,
				'cnt'      => $count
			);

			// Load row template
			$OUT .= loadTemplate('guest_stats_month_row', true, $data);

			if ($SW == 2) {
				$r2 = '';
				$l = 'rl'; $r = 'rr';
			} else {
				$OUT .= '</tr>';
				$r2 = ' right';
				$l = 'll'; $r = 'lr';
			}
			$SW = 3 - $SW;
		} // END - foreach
		$content['month_rows'] = $OUT;

		// Generate category stats
		$OUT = '';
		foreach ($cat_cnt as $id => $count) {
			// Prepare data for the template
			$data = array(
				'cat' => $cats[$id],
				'cnt' => $count,
			);

			// Load row template and switch colors
			$OUT .= loadTemplate('guest_stats_cats_row', true, $data);
		} // END - foreach
		$content['cats_rows'] = $OUT;

		// Load final template
		loadTemplate('guest_stats_member', false, $content);
		break;

	case 'MODULES': // TOP10 module clicks
		// Admins may see all menus
		$AND = " AND `locked`='N' AND `visible`='Y'";
		if (isAdmin()) $AND = '';

		// Query for guest and member menus
		$guest_t10 = SQL_QUERY('SELECT `counter`, `title` FROM `{?_MYSQL_PREFIX?}_guest_menu` WHERE `counter` > 0' . $AND . ' ORDER BY `counter` DESC LIMIT 0,10', __FILE__, __LINE__);
		$mem_t10   = SQL_QUERY('SELECT `counter`, `title` FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE `counter` > 0' . $AND . ' ORDER BY `counter` DESC LIMIT 0,10', __FILE__, __LINE__);
		$OUT = ''; 

		if (!SQL_HASZERONUMS($guest_t10)) {
			// Guest clicks
			$OUT .= loadTemplate('guest_stats_header', true, '{--GUEST_TOP_GUEST_STATS--}');
			while ($content = SQL_FETCHARRAY($guest_t10)) {
				// Load row template
				$OUT .= loadTemplate('guest_stats_row', true, $content);
			} // END - while
		} // END - if

		if (!SQL_HASZERONUMS($mem_t10)) {
			// Member clicks
			$OUT .= loadTemplate('guest_stats_header', true, '{--GUEST_TOP_MEMBER_STATS--}');
			while ($content = SQL_FETCHARRAY($mem_t10)) {
				// Load row template
				$OUT .= loadTemplate('guest_stats_row', true, $content);
			} // END - while
		} // END - if

		if ((!SQL_HASZERONUMS($guest_t10)) || (!SQL_HASZERONUMS($mem_t10))) {
			// Prepare content
			$content = array(
				'rows'   => $OUT,
				'lmode'  => $lmode,
				'ltitle' => $ltitle
			);

			// Load final template
			loadTemplate('guest_stats_table', false, $content);
		} else {
			// No clicks detected
			loadTemplate('admin_settings_saved', false, '{--GUEST_STATS_NO_CLICKS--}');
		}
		break;

	case 'INACTIVE': // Deactivated stats
		loadTemplate('admin_settings_saved', false, '{--GUEST_STATS_DEACTIVATED--}');
		break;
} // END - switch

// [EOF]
?>
