<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/05/2008 *
 * ===================                          Last change: 09/08/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-surfbar_start.php                           *
 * -------------------------------------------------------------------- *
 * Short description : Gives some infos to the surfbar and launch link  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Gibt ein paar Infos zur Surfbar und Startlink    *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} elseif (!isMember()) {
	redirectToIndexMemberOnlyModule();
}

// Add description as navigation point
addYouAreHereLink('member', __FILE__);

if ((!isExtensionActive('surfbar')) && (!isAdmin())) {
	loadTemplate('admin_settings_saved', false, generateExtensionInactiveNotInstalledMessage('surfbar'));
	return;
} // END - if

// Prepare content for output
$content = array(
	'surfbar_total_urls'    => SURFBAR_GET_TOTAL_URLS('ACTIVE', 0)
);

// In dynamic mode we need some more data
if (getConfig('surfbar_pay_model') == 'DYNAMIC') {
	// Prepare content for dynamic surfbar
	$content = array(
		'surfbar_total_urls'  => SURFBAR_GET_TOTAL_URLS('ACTIVE', 0),
	);
} // END - if

// Load the template
loadTemplate('member_surfbar_start_' . strtolower(getConfig('surfbar_pay_model')), false, $content);

// Load surfbar link template
loadTemplate('member_surfbar_link');

// [EOF]
?>
